package com.zcloud.basic.info.service;

import com.alibaba.cola.dto.MultiResponse;
import com.zcloud.basic.info.api.RzUserServiceI;
import com.zcloud.basic.info.command.RzUserAddExe;
import com.zcloud.basic.info.command.RzUserRemoveExe;
import com.zcloud.basic.info.command.RzUserUpdateExe;
import com.zcloud.basic.info.command.query.RzUserQueryExe;
import com.zcloud.basic.info.dto.RzUserAddCmd;
import com.zcloud.basic.info.dto.RzUserPageQry;
import com.zcloud.basic.info.dto.RzUserListQry;
import com.zcloud.basic.info.dto.RzUserUpdateCmd;
import com.zcloud.basic.info.dto.clientobject.RzUserCO;

import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.SingleResponse;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

/**
 * web-app
 *
 * @Author SondonYong
 * @Date 2025-12-02 17:15:57
 */
@Service
@AllArgsConstructor
public class RzUserServiceImpl implements RzUserServiceI {
    private final RzUserAddExe rzUserAddExe;
    private final RzUserUpdateExe rzUserUpdateExe;
    private final RzUserRemoveExe rzUserRemoveExe;
    private final RzUserQueryExe rzUserQueryExe;

    @Override
    public PageResponse<RzUserCO> listPage(RzUserPageQry qry) {
        return rzUserQueryExe.execute(qry);
    }

    @Override
    public MultiResponse<RzUserCO> list(RzUserListQry qry) {
        return rzUserQueryExe.execute(qry);
    }

    @Override
    public SingleResponse<RzUserCO> getInfoById(Long id) {
        return rzUserQueryExe.execute(id);
    }

    @Override
    public SingleResponse add(RzUserAddCmd cmd) {
        rzUserAddExe.execute(cmd);
        return SingleResponse.buildSuccess();
    }

    @Override
    public void edit(RzUserUpdateCmd cmd) {
        rzUserUpdateExe.execute(cmd);
    }

    @Override
    public void remove(Long id) {
        rzUserRemoveExe.execute(id);
    }

    @Override
    public void removeBatch(Long[] ids) {
        rzUserRemoveExe.execute(ids);
    }
}

